Index: source/scriptinterface/ScriptTypes.h
===================================================================
--- source/scriptinterface/ScriptTypes.h	(Revision 14578)
+++ source/scriptinterface/ScriptTypes.h	(Arbeitskopie)
@@ -33,42 +33,32 @@
 // the ones that are needed and this avoids conflicting definitions
 # define JS_SYS_TYPES_H_DEFINES_EXACT_SIZE_TYPES
 
+
 #else // If not Windows, then Unix:
 
 # define XP_UNIX
 
-// In DEBUG mode, jsval defaults to struct types. Normally we build separate
-// debug/release mode versions of the library, but when using --with-system-mozjs185
-// it's always a release mode library, so we have to disable struct types for
-// ABI compatibility
-# if defined(DEBUG) && defined(WITH_SYSTEM_MOZJS185)
-#  define JS_NO_JSVAL_JSID_STRUCT_TYPES
-# endif
-
 #endif
 // (we don't support XP_OS2 or XP_BEOS)
 
 
 // Guess whether the library was compiled with the release-mode or debug-mode ABI
 // (for JS_DumpHeap etc)
-#if defined(DEBUG) && !defined(WITH_SYSTEM_MOZJS185)
+#if defined(DEBUG) && !defined(WITH_SYSTEM_MOZJS24)
 # define MOZJS_DEBUG_ABI 1
 #else
 # define MOZJS_DEBUG_ABI 0
 #endif
 
-
-// SpiderMonkey wants the DEBUG flag
-#ifndef NDEBUG
-# ifndef DEBUG
-#  define DEBUG
-# endif
-#endif
-
 // Ignore some harmless warnings triggered by jsapi.h
-#if GCC_VERSION >= 402 // (older GCCs don't support this pragma)
+// TODO: Optimize this for different GCC versions if we find a list which pragma is supported in which version of GCC)
+// Also some versions of GCC will still print warnings (see http://gcc.gnu.org/bugzilla/show_bug.cgi?id=53431).
+#if GCC_VERSION >= 402 
 # pragma GCC diagnostic ignored "-Wunused-parameter"
 # pragma GCC diagnostic ignored "-Wredundant-decls"
+# pragma GCC diagnostic ignored "-Wundef"
+# pragma GCC diagnostic ignored "-Wignored-qualifiers"
+# pragma GCC diagnostic ignored "-Wnon-virtual-dtor"
 #endif
 #if MSC_VERSION
 # pragma warning(push)
@@ -76,22 +66,27 @@
 # pragma warning(disable:4100) // "unreferenced formal parameter"
 #endif
 
-#include "js/jsapi.h"
+#include "jspubtd.h"
+#include "jsapi.h"
 
+
 #if MSC_VERSION
 # pragma warning(pop)
 #endif
 #if GCC_VERSION >= 402
 # pragma GCC diagnostic warning "-Wunused-parameter"
 # pragma GCC diagnostic warning "-Wredundant-decls"
+# pragma GCC diagnostic warning "-Wundef"
+# pragma GCC diagnostic warning "-Wignored-qualifiers"
+# pragma GCC diagnostic warning "-Wnon-virtual-dtor"
 #endif
 
-#if JS_VERSION != 185
-#error Your compiler is trying to use an incorrect version of the SpiderMonkey library.
-#error The only version that works is the one in the libraries/spidermonkey/ directory,
-#error and it will not work with a typical system-installed version.
-#error Make sure you have got all the right files and include paths.
-#endif
+//#if MOZJS_MAJOR_VERSION != 24 || MOZJS_MINOR_VERSION != 0
+//#error Your compiler is trying to use an incorrect version of the SpiderMonkey library.
+//#error The only version that works is the one in the libraries/spidermonkey/ directory,
+//#error and it will not work with a typical system-installed version.
+//#error Make sure you have got all the right files and include paths.
+//#endif
 
 class ScriptInterface;
 class CScriptVal;
Index: source/scriptinterface/NativeWrapperDecls.h
===================================================================
--- source/scriptinterface/NativeWrapperDecls.h	(Revision 14578)
+++ source/scriptinterface/NativeWrapperDecls.h	(Arbeitskopie)
@@ -26,7 +26,7 @@
 #define NUMBERED_LIST_BALANCED(z, i, data) BOOST_PP_COMMA_IF(i) data##i
 // Some other things
 #define TYPED_ARGS(z, i, data) , T##i a##i
-#define CONVERT_ARG(z, i, data) T##i a##i; if (! ScriptInterface::FromJSVal<T##i>(cx, i < argc ? JS_ARGV(cx, vp)[i] : JSVAL_VOID, a##i)) return JS_FALSE;
+#define CONVERT_ARG(z, i, data) T##i a##i; if (! ScriptInterface::FromJSVal<T##i>(cx, i < argc ? JS_ARGV(cx, vp)[i] : JSVAL_VOID, a##i)) return false;
 
 // List-generating macros, named roughly after their first list item
 #define TYPENAME_T0_HEAD(z, i) BOOST_PP_REPEAT_##z (i, NUMBERED_LIST_HEAD, typename T) // "typename T0, typename T1, "
@@ -51,14 +51,14 @@
 // (Definition comes later, since it depends on some things we haven't defined yet)
 #define OVERLOADS(z, i, data) \
 	template <typename R, TYPENAME_T0_HEAD(z,i)  R (*fptr) ( ScriptInterface::CxPrivate* T0_TAIL(z,i) )> \
-	static JSBool call(JSContext* cx, uintN argc, jsval* vp);
+	static JSBool call(JSContext* cx, uint32_t argc, jsval* vp);
 BOOST_PP_REPEAT(SCRIPT_INTERFACE_MAX_ARGS, OVERLOADS, ~)
 #undef OVERLOADS
 
 // Similar, for class methods
 #define OVERLOADS(z, i, data) \
 	template <typename R, TYPENAME_T0_HEAD(z,i)  JSClass* CLS, typename TC, R (TC::*fptr) ( T0(z,i) )> \
-	static JSBool callMethod(JSContext* cx, uintN argc, jsval* vp);
+	static JSBool callMethod(JSContext* cx, uint32_t argc, jsval* vp);
 BOOST_PP_REPEAT(SCRIPT_INTERFACE_MAX_ARGS, OVERLOADS, ~)
 #undef OVERLOADS
 
Index: source/scriptinterface/ScriptVal.cpp
===================================================================
--- source/scriptinterface/ScriptVal.cpp	(Revision 14578)
+++ source/scriptinterface/ScriptVal.cpp	(Arbeitskopie)
@@ -17,19 +17,24 @@
 
 #include "precompiled.h"
 
+#include "ScriptInterface.h"
 #include "ScriptVal.h"
 
-#include "js/jsapi.h"
 
 struct Unrooter
 {
 	Unrooter(JSContext* cx) : cx(cx) { }
-	void operator()(jsval* p) { JS_RemoveValueRoot(cx, p); delete p; }
+	void operator()(jsval* p)
+	{
+        JSAutoRequest rq(cx);
+		JS_RemoveValueRoot(cx, p); delete p;
+    }
 	JSContext* cx;
 };
 
 CScriptValRooted::CScriptValRooted(JSContext* cx, jsval val)
 {
+    JSAutoRequest rq(cx);
 	jsval* p = new jsval(val);
 	JS_AddNamedValueRoot(cx, p, "CScriptValRooted");
 	m_Val = boost::shared_ptr<jsval>(p, Unrooter(cx));
@@ -37,6 +42,7 @@
 
 CScriptValRooted::CScriptValRooted(JSContext* cx, CScriptVal val)
 {
+    JSAutoRequest rq(cx);
 	jsval* p = new jsval(val.get());
 	JS_AddNamedValueRoot(cx, p, "CScriptValRooted");
 	m_Val = boost::shared_ptr<jsval>(p, Unrooter(cx));
@@ -49,6 +55,11 @@
 	return *m_Val;
 }
 
+void CScriptValRooted::getPtr(JS::Value** val)
+{
+	*val = &*m_Val;
+}
+
 jsval& CScriptValRooted::getRef() const
 {
 	ENSURE(m_Val);
@@ -65,6 +76,7 @@
 	return !m_Val;
 }
 
+/*
 AutoJSIdArray::AutoJSIdArray(JSContext* cx, JSIdArray* ida) :
 	m_Context(cx), m_IdArray(ida)
 {
@@ -85,7 +97,7 @@
 {
 	if (!m_IdArray)
 		return 0;
-	return m_IdArray->length;
+	return JS_IdArrayLength(m_Context, m_IdArray);
 }
 
 jsid AutoJSIdArray::operator[](size_t i) const
@@ -93,4 +105,13 @@
 	if (!(m_IdArray && i < (size_t)m_IdArray->length))
 		return JSID_VOID;
 	return m_IdArray->vector[i];
-}
+}*/
+
+
+//CRootedWrapper::CRootedWrapper(JSContext* cx, JS::Value val)
+//{
+//	JSAutoRequest rq(cx);
+//	JS::Value* wrap = &val;
+//	JS_WrapValue(cx, val);
+//	m_Val = boost::shared_ptr<JS::Value>(wrap, Unrooter(cx));
+//}
Index: source/scriptinterface/NativeWrapperDefns.h
===================================================================
--- source/scriptinterface/NativeWrapperDefns.h	(Revision 14578)
+++ source/scriptinterface/NativeWrapperDefns.h	(Arbeitskopie)
@@ -79,11 +79,11 @@
 #define SCRIPT_PROFILE \
 	if (g_ScriptProfilingEnabled) \
 	{ \
-		ENSURE(JSVAL_IS_OBJECT(JS_CALLEE(cx, vp)) && JS_ObjectIsFunction(cx, JSVAL_TO_OBJECT(JS_CALLEE(cx, vp)))); \
+		ENSURE(!JSVAL_IS_PRIMITIVE(JS_CALLEE(cx, vp)) && JS_ObjectIsFunction(cx, JSVAL_TO_OBJECT(JS_CALLEE(cx, vp)))); \
 		const char* name = "(unknown)"; \
 		jsval nameval; \
-		if (JS_GetReservedSlot(cx, JSVAL_TO_OBJECT(JS_CALLEE(cx, vp)), 0, &nameval) \
-			&& !JSVAL_IS_VOID(nameval)) \
+		nameval = JS_GetReservedSlot(JSVAL_TO_OBJECT(JS_CALLEE(cx, vp)), 0); \
+		if (!JSVAL_IS_VOID(nameval)) \
 			name = static_cast<const char*>(JSVAL_TO_PRIVATE(nameval)); \
 		CProfileSampleScript profile(name); \
 	}
@@ -91,14 +91,14 @@
 // JSFastNative-compatible function that wraps the function identified in the template argument list
 #define OVERLOADS(z, i, data) \
 	template <typename R, TYPENAME_T0_HEAD(z,i)  R (*fptr) ( ScriptInterface::CxPrivate* T0_TAIL(z,i) )> \
-	JSBool ScriptInterface::call(JSContext* cx, uintN argc, jsval* vp) { \
+	JSBool ScriptInterface::call(JSContext* cx, uint32_t argc, jsval* vp) { \
 		UNUSED2(argc); \
 		SCRIPT_PROFILE \
 		BOOST_PP_REPEAT_##z (i, CONVERT_ARG, ~) \
 		jsval rval = JSVAL_VOID; \
 		ScriptInterface_NativeWrapper<R>::call(cx, rval, fptr  A0_TAIL(z,i)); \
 		JS_SET_RVAL(cx, vp, rval); \
-		return (ScriptInterface::IsExceptionPending(cx) ? JS_FALSE : JS_TRUE); \
+		return !ScriptInterface::IsExceptionPending(cx); \
 	}
 BOOST_PP_REPEAT(SCRIPT_INTERFACE_MAX_ARGS, OVERLOADS, ~)
 #undef OVERLOADS
@@ -106,17 +106,17 @@
 // Same idea but for methods
 #define OVERLOADS(z, i, data) \
 	template <typename R, TYPENAME_T0_HEAD(z,i)  JSClass* CLS, typename TC, R (TC::*fptr) ( T0(z,i) )> \
-	JSBool ScriptInterface::callMethod(JSContext* cx, uintN argc, jsval* vp) { \
+	JSBool ScriptInterface::callMethod(JSContext* cx, uint32_t argc, jsval* vp) { \
 		UNUSED2(argc); \
 		SCRIPT_PROFILE \
-		if (ScriptInterface::GetClass(cx, JS_THIS_OBJECT(cx, vp)) != CLS) return JS_FALSE; \
-		TC* c = static_cast<TC*>(ScriptInterface::GetPrivate(cx, JS_THIS_OBJECT(cx, vp))); \
-		if (! c) return JS_FALSE; \
+		if (ScriptInterface::GetClass(JS_THIS_OBJECT(cx, vp)) != CLS) return false; \
+		TC* c = static_cast<TC*>(ScriptInterface::GetPrivate(JS_THIS_OBJECT(cx, vp))); \
+		if (! c) return false; \
 		BOOST_PP_REPEAT_##z (i, CONVERT_ARG, ~) \
 		jsval rval = JSVAL_VOID; \
 		ScriptInterface_NativeMethodWrapper<R, TC>::call(cx, rval, c, fptr  A0_TAIL(z,i)); \
 		JS_SET_RVAL(cx, vp, rval); \
-		return (ScriptInterface::IsExceptionPending(cx) ? JS_FALSE : JS_TRUE); \
+		return !ScriptInterface::IsExceptionPending(cx); \
 	}
 BOOST_PP_REPEAT(SCRIPT_INTERFACE_MAX_ARGS, OVERLOADS, ~)
 #undef OVERLOADS
Index: source/scriptinterface/ScriptStats.cpp
===================================================================
--- source/scriptinterface/ScriptStats.cpp	(Revision 14578)
+++ source/scriptinterface/ScriptStats.cpp	(Arbeitskopie)
@@ -21,8 +21,6 @@
 
 #include "scriptinterface/ScriptInterface.h"
 
-#include "js/jsapi.h"
-
 CScriptStatsTable* g_ScriptStatsTable;
 
 enum
